/*
 jasciimovie V2.0
 Syncronized text display from file for compressed asciigrab-movies 

V1.0 A. Schiffler, 05/1999
- initial version without any features
V2.0 A. Schiffler, Fri Oct 15 14:23:42 CEST 1999
- added many parameters
- added compressed stream input
- added restart-icon and restart functionality

*/

import java.applet.*;
import java.awt.*;
import java.io.*;
import java.awt.event.*;
import java.net.*;
import java.lang.*;
import java.util.zip.*;

public class jasciimovie extends Applet implements Runnable, MouseListener 
{
 Dimension size;
 Image buffer;
 Graphics bufferGraphics;
 Thread animator;
 boolean please_stop;
 boolean please_restart;
 boolean please_pause;
 boolean pause_drawn;
 Color foreground = null;
 Color background = null;
 Image backbutton = null;
 Image pausebutton = null;
 Image stopbutton = null;
 Image copyrightbutton = null;
 int pausetime;
 int fontsize;
 int fontwidth;
 int cornerx,cornery,sizex,sizey,numlines,maxwidth;
 Font font;
 URL url = null;
 InputStream instream = null;
 GZIPInputStream gzipinstream = null;
 InputStreamReader instreamreader = null;
 BufferedReader in = null;
 String line;
 int framecount;
 int framecountcopyright;

 protected Color getColorParameter(String name) 
 {
  String value = this.getParameter(name);
  try { return new Color(Integer.parseInt(value, 16)); } 
   catch (Exception e) { return null; }
 }

 public void init() 
 {
  Integer Fontsize = null;
  Boolean tempboolean = null;
  Integer tempinteger = null;
  int framerate;

  // Set default cursor
  this.setCursor(Cursor.getPredefinedCursor(Cursor.HAND_CURSOR));

  // Load images
  backbutton = this.getImage(this.getDocumentBase(),"back.gif");
  pausebutton = this.getImage(this.getDocumentBase(),"pause.gif");
  stopbutton = this.getImage(this.getDocumentBase(),"stop.gif");
  copyrightbutton = this.getImage(this.getDocumentBase(),"copyright.gif");

  // Create backbuffer  
  size = this.getSize();
  buffer = this.createImage(size.width, size.height);
  bufferGraphics = buffer.getGraphics();

  // initialize border variables
  sizex=size.width;
  sizey=size.height;
  numlines=0;
  maxwidth=0;
  cornerx=0;
  cornery=0;

  // setup framecounters
  framecount=0;

  // Get size of font 
  Fontsize=new Integer(getParameter("fontsize"));
  font = new Font("Courier",Font.PLAIN,Fontsize.intValue());
  fontsize=Fontsize.intValue();
  
  // Autorepeat
  tempboolean=new Boolean(getParameter("repeat"));
  please_restart=tempboolean.booleanValue();

  // Playback framerate
  tempinteger=new Integer(getParameter("fps"));
  framerate=tempinteger.intValue();
  if (framerate<1) framerate=1;
  if (framerate>25) framerate=25;
  pausetime=1000/framerate;

  // setup framecounters
  framecount=0;
  framecountcopyright=framerate*2;
 
  // Colorsetup
  foreground = getColorParameter("foreground");
  background = getColorParameter("background");
  if (foreground != null) this.setForeground(foreground);
  if (background != null) this.setBackground(background);

  // Mouse callback
  this.addMouseListener(this);

  // Play it ...
  start();
 }

 public void paint(Graphics g) 
 {
  int i,linelen;
  boolean firsttime,inloop;

  if ((!please_pause) || (!pause_drawn)) {

   // clear
   bufferGraphics.setColor(background);
   bufferGraphics.fillRect(0,0,size.width,size.height);
   
   // setup foreground
   bufferGraphics.setColor(foreground);
   bufferGraphics.setFont(font);

   try {
    i=0;
    inloop=true;
    if (line==null) {
     firsttime=true;
    } else {
     bufferGraphics.drawString(line.substring(3),cornerx+fontsize,cornery+fontsize*(i+1));
     i++;
     firsttime=false;
    }
    while (inloop) {
     if (in==null) {
      inloop=false;
      stop();
     } else {
      line = in.readLine();
      if (line==null) {
       inloop=false;
       stop();
      } else {
       if  (line.substring(0,3).compareTo("\033[H")!=0) {
        FontMetrics fontm = Toolkit.getDefaultToolkit().getFontMetrics(font);
        linelen=fontm.stringWidth(line)-fontsize;
        if (linelen>maxwidth) {
         maxwidth=linelen;
         cornerx=(sizex-maxwidth)/2;
        }
        bufferGraphics.drawString(line,cornerx+fontsize,cornery+fontsize*(i+1));
       } else {
        if (firsttime) {
         bufferGraphics.drawString(line.substring(3),cornerx+fontsize,cornery+fontsize*(i+1));
         firsttime=false;
        } else {
         inloop=false;
        }
       }
       i++;
       if (i>numlines) {
        numlines=i;
        cornery=(sizey-fontsize*numlines)/2;
       }
      }
     }
    }
   } catch (Exception e) { 
    if (please_restart) {
     start();
    }
   }

   // draw buttons
   if (please_restart) {
    bufferGraphics.drawImage(backbutton,0,0,this);
   } else {
    bufferGraphics.drawImage(stopbutton,0,0,this);
   }
   if (please_pause) {
    bufferGraphics.drawImage(pausebutton,backbutton.getWidth(this),0,this);
    pause_drawn=true;
    framecount=framecountcopyright;
   }

   // Draw copyright
   if (framecount<framecountcopyright) {
    bufferGraphics.drawImage(copyrightbutton,sizex-copyrightbutton.getWidth(this),0,this);
   }

   // update framecount
   framecount++;

   // swap buffers 
   g.drawImage(buffer,0,0,this);
  }
 } 
 
 public void update(Graphics g)
 {
  paint(g);
 }

 public void run() 
 {
  while(!please_stop) {
   repaint();

   try { Thread.sleep(pausetime); } catch (InterruptedException e) { ; }
  }
  animator=null;
  try { in.close(); } catch (Exception e) { ; }
  if (please_restart) {
   start();
  }
 }

 public void start()
 {
  if (animator==null) {
   try {
    URL basename=this.getDocumentBase();
    String filename = basename.toString();
    filename = filename.substring(0,filename.lastIndexOf("/")+1);
    filename = filename.concat(getParameter("filename"));

    System.err.println(filename);
   
    url = new URL(filename);
    instream = url.openStream();
    gzipinstream = new GZIPInputStream(instream);
    instreamreader = new InputStreamReader(gzipinstream); 
    in = new BufferedReader(instreamreader);
   } catch (Exception e) { System.err.println("start: "+e); }
   if (in!=null) {
    please_stop=false;
    pause_drawn=false;
    animator = new Thread(this);
    animator.start();
   } else {
    System.err.println("Cannot open "+getParameter("URL"));
   }
  }
 }

 public void stop()
 {
  please_stop = true;
 }


 public void mousePressed(MouseEvent e)
 {
  int x=e.getX();
  int y=e.getY();

  if ((x<backbutton.getWidth(this)) && (y<backbutton.getHeight(this))) {
   stop(); 
   please_pause=false;
  } else {
   please_pause = !please_pause;
   if (!please_pause) {
    pause_drawn=false;
   }
  }
 }

 public void mouseReleased(MouseEvent e) {;}
 public void mouseClicked(MouseEvent e) {;}
 public void mouseEntered(MouseEvent e) {;}
 public void mouseExited(MouseEvent e) {;}

}
